"""
Dati su novčići od 1, 2, 5, 10, 20 dinara. Napisati program koji pronalazi sve
moguće kombinacije tako da zbir svih novčića bude 50
"""
import constraint
problem = constraint.Problem()
problem.addVariable("1 din", range(0, 51))
problem.addVariable("2 din", range(0, 26))
problem.addVariable("5 din", range(0, 11))
problem.addVariable("10 din", range(0, 6))
problem.addVariable("20 din", range(0, 3))

def suma(din1, din2, din5, din10, din20):
  if din1*1 + din2*2 + din5*5 + din10*10 + din20*20 == 50:
    return True
#problem.addConstraint(suma, ["1 din", "2 din", "5 din", "10 din", "20 din"])
problem.addConstraint(
    constraint.ExactSumConstraint(50, [1, 2, 5, 10, 20]),
    ["1 din", "2 din", "5 din", "10 din", "20 din"])
problem.addConstraint(constraint.AllDifferentConstraint())
resenja = problem.getSolutions()
for r in resenja:
  print("""
  1 din: {0:d}
  2 din: {1:d}
  5 din: {2:d}
  10 din: {3:d}
  20 din: {4:d}
   """.format(r['1 din'], r['2 din'], r['5 din'], r['10 din'], r['20 din'])) # ''' '''
