"""
Napisati program koji pronalazi sve vrednosti promenljivih X, Y, Z i W za koje
važi da je X >= 2 ∗ W , 3 + Y <= Z i X − 11 ∗ W + Y + 11 ∗ Z <= 100 pri čemu promenljive
pripadaju narednim domenima X ∈ {1, 2, ..., 10}, Y ∈ {1, 3, 5, ...51}, Z ∈ {10, 20, 30, ..., 100} i
W ∈ {1, 8, 27, ..., 1000}.
"""

import constraint
problem = constraint.Problem()
problem.addVariable("x", range(1, 91))
problem.addVariable('y', range(2, 61, 2))
problem.addVariable('z', [i*i for i in range(1, 11)])
def o2(x, z):
  if x >= z:
    return True

def o3(x, y, z):
  if 2*x + y*x +z <= 34:
    return True
problem.addConstraint(o2, "xz")
problem.addConstraint(o3, "xyz")
problem.addConstraint(constraint.AllDifferentConstraint())
resenja = problem.getSolutions()
for r in resenja:
  print("----------------")
  print("x: {0:d}, y: {1:d}, z: {2:d}".format(r['x'], r['y'], r['z']))
  print("----------------\n")
