"""
Napisati program koji na standardni izlaz ispisuje sve kombinacije oblika xyz,
gde je x ∈ {a, b, c}, y ∈ {1, 2, 3} i z ∈ {0.1, 0.2, 0.3} tako da važi da je 10 · z = y.

"""
import constraint
problem = constraint.Problem()
problem.addVariable("x", ["a", "b", "c"])
problem.addVariable("y", [1, 2, 3])
problem.addVariable("z", [0.1, 0.2, 0.3])
def ogranicenje(y, z):
  if 10*z == y:
    return True
problem.addConstraint(ogranicenje, ['y', 'z'])
resenja = problem.getSolutions()
#print(resenja)
for resenje in resenja:
  print(
      "xyz: {0:s} {1:d} {2:.2f}"
      .format(resenje['x'], resenje['y'], resenje['z'])
      )
