"""
Napisati program koji pronalazi trocifren broj ABC tako da je količnik ABC/(A + B + C) minimalan i A, B i C su različiti brojevi
"""
import constraint
problem = constraint.Problem()
problem.addVariable('A', range(1, 10))
problem.addVariables(['B', 'C'], range(0, 10))
problem.addConstraint(constraint.AllDifferentConstraint())

resenja = problem.getSolutions()
#print(resenja)

min_resenje = {}
min_kolicnik = 1000
for r in resenja:
  if (r['A']*100+r['B']*10+r['C'])/(r['A']+r['B']+r['C']) < min_kolicnik:
    min_kolicnik = (r['A']*100+r['B']*10+r['C'])/(r['A']+r['B']+r['C'])
    min_resenje = r

print(min_resenje['A']*100 + min_resenje['B']*10 + min_resenje['C'])
