"""
Napisati program koji ređa brojeve u magičan kvadrat. Magičan kvadrat
je kvadrat dimenzija 3x3 takav da je suma svih brojeva u svakom redu, svakoj koloni i svakoj
dijagonali jednak 15 i svi brojevi različiti.
"""

import constraint
problem = constraint.Problem()
problem.addVariables("abcdefghi", range(1, 10))

def o1(x, y, z):
  if x + y + z == 15:
    return True

problem.addConstraint(constraint.AllDifferentConstraint())
"""
a b c
d e f
g h i
"""
# abc
problem.addConstraint(o1, "abc")
# def
problem.addConstraint(o1, "def")
# ghi
problem.addConstraint(o1, "ghi")
# adg
problem.addConstraint(o1, "adg")
# beh
problem.addConstraint(o1, "beh")
# cfi
problem.addConstraint(o1, "cfi")
problem.addConstraint(o1, "aei")
problem.addConstraint(o1, "ceg")
resenja = problem.getSolutions()
#print(resenja)
for r in resenja:
  print("-------------")
  print("{0:d} {1:d} {2:d}".format(r['a'], r['b'], r['c']))
  print("{0:d} {1:d} {2:d}".format(r['d'], r['e'], r['f']))
  print("{0:d} {1:d} {2:d}".format(r['g'], r['h'], r['i']))
  print("-------------\n")

